function varargout=setMesh3Ds(varargin)
  p = inputParser; 
  p.KeepUnmatched=true;
  p.addParamValue('verbose',true,@islogical);
  p.addParamValue('geofile','demisphere5',@ischar);
  p.addParamValue('N',30,@isscalar);
  p.parse(varargin{:});
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  verbose=p.Results.verbose;
  geofile=p.Results.geofile;
  N=p.Results.N;
  if verbose,fprintf('*** Building the mesh file\n');end
  meshfile=fc_oogmsh.buildmesh3ds(geofile,N,varargin{:});
  if verbose,fprintf('*** Creating siMesh object by reading the mesh file\n');end
  Th=fc_simesh.siMesh(meshfile);
  if verbose,Th.info();end
  varargout{1}=Th;
  if nargout==2
    varargout{2}=verbose;
  end
end
